#!/usr/bin/env python3
"""

See EOF for license/metadata/notes as applicable
"""

##-- builtin imports
from __future__ import annotations

# import abc
import datetime
import enum
import functools as ftz
import itertools as itz
import logging as logmod
import pathlib as pl
import re
import time
import types
import weakref
# from copy import deepcopy
# from dataclasses import InitVar, dataclass, field
from typing import (TYPE_CHECKING, Any, Callable, ClassVar, Final, Generic,
                    Iterable, Iterator, Mapping, Match, MutableMapping,
                    Protocol, Sequence, Tuple, TypeAlias, TypeGuard, TypeVar,
                    cast, final, overload, runtime_checkable, Generator)
from uuid import UUID, uuid1

##-- end builtin imports

##-- lib imports
# import more_itertools as mitz
# from boltons import
##-- end lib imports

##-- logging
logging = logmod.getLogger(__name__)
##-- end logging

class DootKeyGetter:
    """
      The core logic to turn a key into a value.
      Doesn't perform repeated expansions.

      tries sources in order.
    """

    @staticmethod
    def chained_get(key:str, *sources:dict|DootLocations) -> Any:
        # cli   : dict          = doot.args.on_fail({}).tasks[str(state.get(STATE_TASK_NAME_K, None))]()
        # replacement           = cli.get(key, None)
        # *Not* elif's, want it to chain.
        for source in sources:
            if source is None:
                continue
            replacement = source.get(key, None)
            if replacement is not None:
                return replacement

        return None
